(function (Drupal, $) {

  Drupal.behaviors.modalMenuBlockExpandable = {
    attach: function (context) {
      const menus = once('modalMenuBlockExpandable', '.modal-menu-block.expandable');
      menus.forEach(menu => {
        // Add an "opener" element to LIs which have ULs.
        $('li', menu).each((idx, item) => {
          $(item).children('ul').before('<a class="modal-menu-block--opener"></a>');
        });

        // Bind to opener's click event.
        $('.modal-menu-block--opener', menu).on('click', function (event) {
          event.preventDefault();
          Drupal.modalMenuBlockExpandable.openerClicked(this);
        });
      });
    }
  };

  /**
   * This code is split out from the behavior to allow the expand/collapse to
   * be easily overridden by a theme, etc.
   */
  Drupal.modalMenuBlockExpandable = {
    collapseChildren: function (el) {
      this.defaultCollapseExpand(el, false);
    },
    expandChildren: function (el) {
      this.defaultCollapseExpand(el, true);
    },
    openerClicked: function (el) {
      const $list = $(el).parent('li');
      const list = $list.get(0);
      if (list && $list.hasClass('expanded')) {
        this.collapseChildren(list);
      }
      else {
        this.expandChildren(list);
      }
    },
    defaultCollapseExpand: function (el, state) {
      $(el).toggleClass('expanded', state).children('ul').slideToggle(state);
    }
  };

})(Drupal, jQuery)
